#ifndef code__unicode__decoding_hxx_
#define code__unicode__decoding_hxx_

#include <code/unicode/unicode.hxx>

#include <cstdint>
#include <istream>
#include <iterator>

namespace code::unicode
{

  class Decoder
  {
  public:
    virtual
    ~Decoder() = default;

    virtual
    std::uint32_t
    extract(std::istream& i) const = 0;

  };

  class Utf8_decoder
    : public Decoder
  {
  public:
    std::uint32_t
    extract(std::istream& i) const override;

    template< typename InputIterator >
    std::uint32_t
    decode(InputIterator& it, InputIterator const& end) const;

    template< typename InputIterator >
    std::uint32_t
    decode(InputIterator&& it, InputIterator const& end) const
    {
      return decode(it, end);
    }

  };

} // namespace code::unicode

#include <code/unicode/decoding.ixx>
#include <code/unicode/decoding.txx>

#endif
