#ifndef code__unicode__encoding_hxx_
#define code__unicode__encoding_hxx_

#include <cstdint>
#include <ostream>

namespace code::unicode
{

  class Encoder
  {
  public:
    virtual
    ~Encoder() = default;

    virtual
    void
    encode(std::ostream& o, std::uint32_t c) const = 0;

  };

  class Utf8_encoder
    : public Encoder
  {
  public:
    void
    encode(std::ostream& o, std::uint32_t c) const override;

  };

} // namespace code::unicode

#include <code/unicode/encoding.ixx>

#endif
