#include <code/unicode/iterator.hxx>

#include <code/validation/main.hxx>

#include <cstdint>
#include <string>

VALIDATION_TEST(test_1)
{
  std::string utf8{"hࠀ𐀀"};

  code::unicode::Utf8_input_iterator<std::string::iterator> it{
    utf8.begin(), utf8.end()
  };

  std::uint32_t c1 = *it++;
  std::uint32_t c2 = *it++;
  std::uint32_t c3 = *it++;
  std::uint32_t c4 = *it++;

  VALIDATION_ASSERT_EQUAL(it, utf8.end());

  VALIDATION_ASSERT_EQUAL(c1, (std::uint32_t)'h');
  VALIDATION_ASSERT_EQUAL(c2, 0x80U);
  VALIDATION_ASSERT_EQUAL(c3, 0x800U);
  VALIDATION_ASSERT_EQUAL(c4, 0x10000U);
}

int
main(int argc, char* argv[])
{
  return code::validation::main(argc, argv);
}
